#ifndef _GAINITIALIZER_H_
#define _GAINITIALIZER_H_

#include <iostream>
#include <fstream>
#include "RandomGenerator.h"
//============================================
//	class Initializer
//============================================
class GAInitializer{
public:

	GAInitializer();

	virtual void createOne(int* gene, int legnth) = 0;
	virtual void createOneFromFile(int* gene, int length, ifstream& fin) = 0;
protected:
	int geneLength;
};

//============================================
//	class RandomInitializer
//============================================
class RandomInitializer : public GAInitializer{
public:
	
	RandomInitializer();
	RandomInitializer(int geneLength);
	
	//ĹlengthĤ
	void createOne(int* gene, int length);
	void createOneFromFile(int* gene, int length, ifstream& fin);
  
private:

	RandomGenerator* random;
    	
};

#endif //_GAINITIALIZER_H_
