#include <vector>
using namespace std;

#include "RandomGenerator.h"

#include "Individual.h"

#ifndef _MUTATION_H_
#define _MUTATION_H_

//============================================
//	class Mutation
//============================================
class Individual;
class Mutation{
public:

	Mutation(){};
	//Ѱۤݥ᥽å
	virtual void mutateOne(Individual& indiv) = 0;

};

//============================================
//	class NormalMutation
//============================================
class NormalMutation : public Mutation{
public:
	//äȤñѰ
	void mutateOne(Individual& indiv);
	double getMutationRate() {
		return mutationRate;
	}
	//Mutation󥹥󥹤֤
	static Mutation& getInstance();
	
private:
	double mutationRate;

	RandomGenerator *randomGenerator;
	
	NormalMutation(){
		mutationRate = Parameter::getInstance().getMutationRate();
		randomGenerator = &RandomGenerator::getInstance();
	}	
};

#endif
