#include "Population.h"

//============================================
//	class Population
//============================================

Population::Population(){
    Parameter *para=&(Parameter::getInstance());
	populationSize = para->getPopulationSize();
	variablesort = false;
	population.resize(populationSize);
}

Individual* Population::getPopulation(int i){
	return &population[i];
}

//GAԤ
void Population::evolve(const int&generation){
	crossover(generation);	//
	mutate();	//Ѱ 
	evaluate();		//ɾ
}

//콸γƸΤѰۤ
void Population::mutate(){
	for(int i=0;i<populationSize;i++){
		population[i].mutate();
	}
}

//콸Ǹ򺵤Ԥ碌
void Population::crossover(const int& generation){
	//ɤθΤڥˤΤꤹ
	OffspringGenerator* offspringGenerator;

	if(variablesort==false){//Ūؿ֤ᥤƥ򤷤ʤ
		offspringGenerator = new ObjectiveNeighborhoodSort(generation);
	}
	else{//߷ѿ֤ᥤƥ򤷤ʤ
		offspringGenerator = new VariableNeighborhoodSort();
	}
	//˵Ȥƥڥꤹ
	offspringGenerator->makePairs(population);
	//˵åե
	offspringGenerator->neighborhood_shuffle();
	//ƸΤ򺵤
	vector<Individual> result;
		
	for(int i=0;i<populationSize/2;i++){
		offspringGenerator->getChild(offspringGenerator->getParents());
		
		for(int j=0;j<2;j++){
			population[j+i*2]=offspringGenerator->getOneChild(j);
		}
	}
	
	delete offspringGenerator;
}

//ɾ
void Population::evaluate(){
	for(int i=0;i<populationSize;i++){
		population[i].evaluation();
	}
}
	
