#include "Truncation.h"

Truncation::Truncation(vector<Individual>& over){
	
	//󥰤뤿˳ŪؿͤκͺǾͤ
	omax = new double[Parameter::getInstance().getObjectiveNum()];
	omin = new double[Parameter::getInstance().getObjectiveNum()];
	for(int i=0;i<Parameter::getInstance().getObjectiveNum();i++){
		omax[i] = over[0].getobjective(i);
		omin[i] = over[0].getobjective(i);
		for(int j=0;j<over.size();j++){
			if(omax[i] < over[j].getobjective(i)){
				omax[i] = over[j].getobjective(i);
			}
			if(omin[i] > over[j].getobjective(i)){
				omin[i] = over[j].getobjective(i);
			}
		}
	}
	//overθΤȤ߹碌ʬ
	obj.resize(over.size()*(over.size()-1)/2);
	var.resize(over.size()*(over.size()-1)/2);
	
	int tmp=0;
	for(int i=0;i<over.size()-1;i++){
		for(int j=i+1;j<over.size();j++){
			obj[tmp].d = over[i].getDistanceObjective(over[j],omax,omin);
			obj[tmp].indiv1 = i;
			obj[tmp].indiv2 = j;
			tmp++;
		}
	}
	tmp = 0;
	for(int i=0;i<over.size()-1;i++){
		for(int j=i+1;j<over.size();j++){
			var[tmp].d = over[i].getDistanceVariable(over[j]);
			var[tmp].indiv1 = i;
			var[tmp].indiv2 = j;
			tmp++;
		}
	}
	
}
	
void Truncation::objtruncation(vector<Individual>& over){
	vector<int> removeNumber;
	removeNumber.resize(0);
	//ǶڥδϢΥ¸Ƥ
	vector<double> pair1,pair2;
	int minpair;
	int ind1,ind2,remove;
	int flag=0;
	//vector<int> removeNumberĤ
	while(over.size()-Parameter::getInstance().getPopulationSize()> removeNumber.size()){
		minpair = 0;
		for(int i=1;i<(int) obj.size();i++){
			if(obj[minpair].d > obj[i].d){
				minpair = i;
			}
		}
		//ǤΥζᤤڥֹ
		ind1 = obj[minpair].indiv1;
		ind2 = obj[minpair].indiv2;
		pair1.clear();
		pair2.clear();
		//pair˵Υ¸Ƥ
		for(int i=0;i<(int) obj.size();i++){
			if(i != minpair){
				if(ind1==obj[i].indiv1 || ind1==obj[i].indiv2){
					pair1.push_back(obj[i].d);
				}
				if(ind2==obj[i].indiv1 || ind2==obj[i].indiv2){
					pair2.push_back(obj[i].d);
				}
			}
		}
		//ᤤʪ¤Ѥ
		sort(pair1.begin(),pair1.end());
		sort(pair2.begin(),pair2.end());
		
		flag=0;
		//ŪؿκǾΤΤͥ褷ƻĤ
		for(int i=0;i<Parameter::getInstance().getObjectiveNum();i++){
			if(omax[i] == over[ind1].getobjective(i) || omin[i] == over[ind1].getobjective(i)){
				remove = ind2;
				flag = 1;
				break;
			}
			if(omax[i] == over[ind2].getobjective(i) || omin[i] == over[ind2].getobjective(i)){
				remove = ind1;
				flag = 1;
				break;
			}
		}
		//ind1,ind2ȤŪؿκǾͤʤä
		if(flag==0){
			for(int i=0;i<(int) pair1.size();i++){
				if(pair1[i] > pair2[i]){
					remove = ind2;
					break;
				}
				else if(pair1[i] < pair2[i]){
					remove = ind1;
					break;
				}
				//ǸޤǵΥʤ
				if(i == pair1.size()-1){
					remove = ind1;
				}
			}
		}
		removeNumber.push_back(remove);
		
		//äͽθΤ˴ؤΥϾä
		int tmp = (int) obj.size();
		for(int i=tmp-1;i>=0;i--){
			if(remove==obj[i].indiv1 || remove==obj[i].indiv2){
				obj.erase(obj.begin()+i);
			}
		}
	}
	//removeNumberˤΤä
	sort(removeNumber.begin(),removeNumber.end());
	for(int i=removeNumber.size()-1;i>=0;i--){
		over.erase(over.begin()+removeNumber[i]);
	}
	
}



void Truncation::vartruncation(vector<Individual>& over){
	vector<int> removeNumber;
	removeNumber.resize(0);
	//ǶڥδϢΥ¸Ƥ
	vector<double> pair1,pair2;
	int minpair;
	int ind1,ind2,remove;
	int flag=0;
	//vector<int> removeNumberĤ
	while(over.size()-Parameter::getInstance().getPopulationSize()> removeNumber.size()){
		minpair = 0;
		for(int i=1;i<(int) var.size();i++){
			if(var[minpair].d > var[i].d){
				minpair = i;
			}
		}
		//ǤΥζᤤڥֹ
		ind1 = var[minpair].indiv1;
		ind2 = var[minpair].indiv2;
		pair1.clear();
		pair2.clear();
		//pair˵Υ¸Ƥ
		for(int i=0;i<var.size();i++){
			if(i != minpair){
				if(ind1==var[i].indiv1 || ind1==var[i].indiv2){
					pair1.push_back(var[i].d);
				}
				if(ind2==var[i].indiv1 || ind2==var[i].indiv2){
					pair2.push_back(var[i].d);
				}
			}
		}
		//ᤤʪ¤Ѥ
		sort(pair1.begin(),pair1.end());
		sort(pair2.begin(),pair2.end());
		
		flag=0;
		//ŪؿκǾΤΤͥ褷ƻĤ
		for(int i=0;i<Parameter::getInstance().getObjectiveNum();i++){
			if(omax[i] == over[ind1].getobjective(i) || omin[i] == over[ind1].getobjective(i)){
				remove = ind2;
				flag = 1;
				break;
			}
			if(omax[i] == over[ind2].getobjective(i) || omin[i] == over[ind2].getobjective(i)){
				remove = ind1;
				flag = 1;
				break;
			}
		}
		//ind1,ind2ȤŪؿκǾͤʤä
		if(flag==0){
			for(int i=0;i<(int) pair1.size();i++){
				if(pair1[i] > pair2[i]){
					remove = ind2;
					break;
				}
				else if(pair1[i] < pair2[i]){
					remove = ind1;
					break;
				}
				//ǸޤǵΥʤ
				if(i == pair1.size()-1){
					remove = ind1;
				}
			}
		}
		removeNumber.push_back(remove);
		
		//äͽθΤ˴ؤΥϾä
		int tmp = var.size();
		for(int i=tmp-1;i>=0;i--){
			if(remove==var[i].indiv1 || remove==var[i].indiv2){
				var.erase(var.begin()+i);
			}
		}
	}
	//removeNumberˤΤä
	sort(removeNumber.begin(),removeNumber.end());
	for(int i=(int) removeNumber.size()-1;i>=0;i--){
		over.erase(over.begin()+removeNumber[i]);
	}
	
}

